var pageNum = 0;
  var firstPageNum = -1;
  var requesting = false;

  window.onscroll = _onscroll;
  var t;
  function _onscroll() {
      if (!requesting && pageNum > -1)
      {
          var top = document.body.scrollTop;
          var screenHeight = window.screen.availHeight;
          var currentPage = document.getElementById("page" + pageNum);

          if (currentPage != null && top >= currentPage.offsetTop - screenHeight){
              window.controller.queryNextPage();
              requesting = true;
          }
      }
      startUpdateCurrentReadPageTimer();
  }

  function startUpdateCurrentReadPageTimer() {
      clearTimeout(t);
      t = setTimeout("updateCurrentReadPage()", 200);
  }

  function updateCurrentReadPage() {
     window.controller.updateCurrentReadPage(getCurrentReadPage());
  }

  function onBodyClick(e) {
      var screenHeight = window.innerHeight;
      var y = e.screenY;
      if (y < screenHeight / 2){
          window.controller.pageUp();
      }else{
          window.controller.pageDown();
      }
      return false;
  }

  function appendPage(){
      pageNum ++;
      var nextDiv = document.getElementById("next");
      if (pageNum == 1){
          // this is the first page, hide the loading div and show the next div
          var loadingDiv = document.getElementById("loading");
          if (loadingDiv != null){
            document.body.removeChild(loadingDiv);
          }else{
            console.log('the loading div is null!');
          }

          showLoading();
          var nextDiv = document.getElementById("next");
          var indexBottomDiv = document.createElement("div");
          indexBottomDiv.setAttribute('id', 'indexBottom');
          document.body.insertBefore(indexBottomDiv, nextDiv);

          var nextDiv = document.getElementById("next");
          var shadowDiv = document.createElement("div");
          indexBottomDiv.setAttribute('id', 'shadow');
          document.body.insertBefore(shadowDiv, nextDiv);

          var nextDiv = document.getElementById("next");
          var allPagesDiv = document.createElement("div");
          allPagesDiv.setAttribute('class', 'allpages');
          allPagesDiv.setAttribute('id', 'allpages');
          document.body.insertBefore(allPagesDiv, nextDiv);

          document.body.addEventListener('click', onBodyClick, false);
      }

      var allPagesDiv = document.getElementById("allpages");
      var pageDiv = document.createElement("div");
      pageDiv.setAttribute('id', ("page" + pageNum));
      pageDiv.innerHTML = "<h2 id='title" + pageNum + "'></h2><div class='maincontent', id='content" + pageNum + "'></div>";

      var pageNumHint = document.createElement("p");
      pageNumHint.setAttribute('class', 'page_footer');
      pageNumHint.innerHTML = "<<span>" + pageNum + "</span>>";
      pageDiv.appendChild(pageNumHint);

      allPagesDiv.appendChild(pageDiv);

      if (document.body.scrollHeight <= window.screen.availHeight){
          window.controller.queryNextPage();
          requesting = true;
      }
      else{
          requesting = false;
      }
  }

  function appendLastPage(contentHTML){
      var allPagesDiv = document.getElementById("allpages");

      var lastPageP = document.createElement("p");
      lastPageP.setAttribute('class', 'last_page');
      lastPageP.innerHTML = contentHTML;

      allPagesDiv.appendChild(lastPageP);
      requesting = true;
  }

  function setContent(contentHTML){
      var content = document.getElementById("content" + pageNum);
      content.innerHTML = contentHTML;
  }

  String.prototype.trim = function() {
      return this.replace(/(^\s*)|(\s*$)/g,"");
  }

  function setTitle(titleHTML){
      var title = document.getElementById("title" + pageNum);
      if (titleHTML.trim().length != 0) {
          title.setAttribute("class", "title");
          title.innerHTML = titleHTML;
      }
  }

  function getCurrentReadPage() {
      var top = document.body.scrollTop;
      var screenHalfHeight = window.innerHeight/2;
      var currentOffset = top + screenHalfHeight;

      var topPageNum = 1;
      var topPage = document.getElementById("page" + topPageNum);
      var bottomPageNum = pageNum;
      var bottomPage = document.getElementById("page" + bottomPageNum);
      var middlePageNum = Math.floor((topPageNum+bottomPageNum)/2);
      var middlePage = document.getElementById("page" + middlePageNum);
      while ((currentOffset < bottomPage.offsetTop) && (bottomPageNum > topPageNum+1)) {
          if (currentOffset > middlePage.offsetTop) {
               topPageNum = middlePageNum;
               topPage = middlePage;
               middlePageNum = Math.floor((topPageNum+bottomPageNum)/2);
               middlePage = document.getElementById("page" + middlePageNum);
          }
          else {
               bottomPageNum = middlePageNum;
               bottomPage = middlePage;
               middlePageNum = Math.floor((topPageNum+bottomPageNum)/2);
               middlePage = document.getElementById("page" + middlePageNum);
          }
      }
      if (currentOffset >= bottomPage.offsetTop) {
          return bottomPageNum;
      }
      else {
          return topPageNum;
      }
  }

  function hideLoading(){
      var nextDiv = document.getElementById("next");
      document.body.removeChild(nextDiv);
  }

  function showLoading(){
    var next = document.createElement("div");
    next.setAttribute("id", "next");
    next.setAttribute("style", "width:100%; height: 40px; display:block;");
    next.setAttribute("class", "footer");
    next.setAttribute("align", "center");
    next.innerHTML = "<image src='images/loading.gif' style='margin-top:5px; margin-bottom:5px'/>";
    document.body.appendChild(next);
  }

  function setTextSize(size){
      var cssRules = document.styleSheets[1].cssRules;
      if (size == 'normal'){
          cssRules[3].style.fontSize = '26px';
          cssRules[4].style.fontSize = '18px';
          cssRules[8].style.fontSize = '18px';
      }
      else if (size == 'larger'){
          cssRules[3].style.fontSize = '28px';
          cssRules[4].style.fontSize = '20px';
          cssRules[8].style.fontSize = '20px';
      }
      else if (size == 'largest'){
          cssRules[3].style.fontSize = '30px';
          cssRules[4].style.fontSize = '22px';
          cssRules[8].style.fontSize = '24px';
      }
      else if (size == 'smaller'){
          cssRules[3].style.fontSize = '24px';
          cssRules[4].style.fontSize = '16px';
          cssRules[8].style.fontSize = '16px';
      }
      else {
          cssRules[3].style.fontSize = '22px';
          cssRules[4].style.fontSize = '14px';
          cssRules[8].style.fontSize = '12px';
      }
  }

  function setNightMode(enabled){
  }

  var isNightMode = window.controller.getIsNightMode();
  setNightMode(isNightMode);

  var textSize = window.controller.getTextSize();
  setTextSize(textSize);